<?php


/**
 * grav version 1.0.8 - install
 *
 * @author Your Name Here
 */
class i_grav_1_1_1_install extends i_action_install
{	//==========================================================================
	// STEP I: INTERNAL CONFIGURABLES
	//==========================================================================
		
	public function step1_init()
		{
				$this->setStepLabel("_step_progress_settings");
				$this->setInputFields(array(
						array(
							"ID" => "sitetitle",
							"LABEL" => "Site Title",
							"TYPE" => "text",
							"VALUE" => "My Grav Site"
							),
				   		array(
				   			"ID" => "login",
				   			"LABEL" => "Username",
				   			"TYPE" => "text"
				   			),
				   		array(
				   			"ID" => "email",
				   			"LABEL" => "Email Address",
				   			"TYPE" => "text"
				   			),
				   		array(
					   		"ID" => "passwd",
					   		"LABEL" => "Password",
					   		"TYPE" => "password"
					   		),
				         array(
				   			"ID" => "fullname",
				   			"LABEL" => "Full Name",
				   			"TYPE" => "text"
				   			),
				   		array(
					   		"ID" => "skeleton",
					   		"LABEL" => "Skeleton Package",
					   		"TEXT" => "A Grav skeleton is an all-in-one package containing the core Grav system plus sample pages, plugins, configuration. These packages are a great way to get started with Grav.",
					   		"TYPE" => "select",
					   		"OPTIONS"=> array(
								"none" => "Grav Core + Admin (Default)",
								"twenty"=>"Twenty",
								"rtfm"=>"RTFM",
								"resume"=>"Resume",
								"onepage"=>"One Page",
								"photographer"=>"Photographer",
								"course"=>"Course Hub"
							)
				   		)
				   	 ));
				
			}
		
	public function step1_process()
	{
		// TIP: error checking for custom inputs can be added here
	}
		
	//==========================================================================
	// STEP II: ARCHIVE EXTRACTION
	//==========================================================================
		
	public function step2_init()
	{
		$this->setStepLabel("_step_progress_extracting");
	}
		
	public function step2_process()
	{
		// extract the 'main' archive:
		$this->extract("main");
	}
		
	//==========================================================================
	// STEP III: CONFIGURING INSTALL
	//==========================================================================
		
	public function step3_init()
	{
		$this->setStepLabel("_step_progress_processing");
	}
		
	public function step3_process()
		{
			$this->mv("grav-admin/*");
			$this->rm("grav-admin");
		               if($this->input['field_skeleton']=="twenty"){
					$this->rm("user/pages/01.home/default.md");
					$this->extract("twenty");
					$this->mv("grav-skeleton-twenty-site/*");
					$this->rm("grav-skeleton-twenty-site");
				}
				if($this->input['field_skeleton']=="rtfm"){
					$this->rm("user/pages/01.home");
					$this->extract("rtfm");
					$this->mv("grav-skeleton-rtfm-site/*");
					$this->rm("grav-skeleton-rtfm-site");
				}
				if($this->input['field_skeleton']=="resume"){
					$this->rm("user/pages/01.home");
					$this->extract("resume");
					$this->mv("grav-skeleton-resume-site/*");
					$this->rm("grav-skeleton-resume-site");
				}
				if($this->input['field_skeleton']=="onepage"){
					$this->rm("user/pages/01.home/default.md");
					$this->extract("onepage");
					$this->mv("grav-skeleton-onepage-site/*");
					$this->rm("grav-skeleton-onepage-site");
				}
				if($this->input['field_skeleton']=="photographer"){
					$this->rm("user/pages/01.home/default.md");
					$this->extract("photographer");
					$this->mv("grav-skeleton-photographer-site/*");
					$this->rm("grav-skeleton-photographer-site");
				}
				if($this->input['field_skeleton']=="course"){
					$this->rm("user/pages/01.home/default.md");
					$this->extract("course");
					$this->mv("grav-skeleton-course-hub-site/*");
					$this->rm("grav-skeleton-course-hub-site");
				}
			$passhashed = crypt($this->input['field_passwd']);
			$this->write("user/accounts/".$this->input['field_login'].".yaml","email: ".$this->input['field_email']."\nfullname: '".$this->input['field_fullname']."'\ntitle: Administrator\nstate: enabled\naccess:\n  admin:\n    login: true\n    super: true\n  site:\n    login: true\nhashed_password: ".$passhashed."");
			$this->sr("user/config/site.yaml", array(
				"#title:(.*)#" => "title: ".$this->input['field_sitetitle'],
				"#name:(.*)#" => "name: ".$this->input['field_fullname'],
				"#email:(.*)#" => "email: '".$this->input['field_email']."'"
			));
		}
}


?>